/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#include "nest_concurrency_model.h"

nestConcurrencyModel::nestConcurrencyModel( int id ) {
    this->id = id;
}

int
nestConcurrencyModel::getId( ) {
    return id;
}

NestReplyStatus 
nestConcurrencyModel::abortTask( nestClient *client ) {
    return NEST_NOT_YET_IMPLEMENTED;
}

NestReplyStatus 
nestConcurrencyModel::pauseTask( nestClient *client ) {
    return NEST_NOT_YET_IMPLEMENTED;
}

NestReplyStatus 
nestConcurrencyModel::updateTaskInfo( nestClient *client ) {
    return NEST_NOT_YET_IMPLEMENTED;
}

NestReplyStatus 
nestConcurrencyModel::sigChild( int num, siginfo_t *sig, void *context,
        fd_set * readyfds ) 
{
        // only POP should have to deal with this
    assert( 0 );
    return NEST_NOT_YET_IMPLEMENTED;
}

NestReplyStatus
nestConcurrencyModel::debugLevel( int new_level ) {
        // if everything in one address space, nothing to do
        // only POP must override this
    return NEST_SUCCESS;
}
