/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_CONCURRENCY_POP_H
#define _NEST_CONCURRENCY_POP_H

#include "nest_concurrency_model.h"
#include "nest_client_pool.h"
#include "nest_worker_pool.h"

class nestConcurrencyPop : public nestConcurrencyModel {
public:
    
    nestConcurrencyPop( int pool_size, fd_set *srvr_read_fds, taskDoneCallback,
            int id );
    
    virtual NestReplyStatus addTask( nestClient *client );
    
    virtual NestReplyStatus makeProgress( fd_set *r_ready, fd_set *w_ready );

    virtual int getMaxfd();

    virtual NestReplyStatus sigChild( int sig, siginfo_t *info, void *context,
            fd_set *ready );

    virtual NestReplyStatus debugLevel( long new_level );

    virtual char* toString();

private:
    int HandleWorkerMessages( fd_set *r_ready );
    void testWorkers( );
    void replaceDeadChildren( int quantity );
    void assignPendingReqs( int new_idle_workers );

    
    nestClientPool   *pendingReqs;
    nestWorkerPool   *workers;
    taskDoneCallback taskDone;
    fd_set           *readfds;
    int              deadKids;
};

#endif
