/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef NEST_HASH_TABLE_H
#define NEST_HASH_TABLE_H

#include "nest_common.h"

struct nest_hash_table * nest_hash_table_create( 
        int buckets, int (*hashfunc)( const char * ) );

void nest_hash_table_delete( struct nest_hash_table *h );

void * nest_hash_table_lookup( struct nest_hash_table *h, const char *key );

int nest_hash_table_insert( 
        struct nest_hash_table *h, const char *key, void *value );

int nest_hash_table_remove( struct nest_hash_table *h, const char *key );

int nest_hash_table_size( struct nest_hash_table *h );

// iterator function can return 0 to stop the iteration. 
int nest_hash_table_iterate( struct nest_hash_table *h, 
        int (*iterator) ( const char *key, void *item, void *arg ), void *arg );

int nest_hash_string( char *s );

int nest_hash_int( char *s );

#endif
