/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef NEST_SPEAK_I_H
#define NEST_SPEAK_I_H

/*
file class is for nest_speak (nest protocol specific functions) which do
not need to be accessible to the client, but need to be accessible by
the protocol manager
*/

#include <stdio.h>
#include "nest_speak.h"

NestReplyStatus
myNestOpenConnection( NestConnection &con, const char *nestlocation, bool anon,
        bool user_user_auth, int port );

bool SendNestMessage( NestConnection con, const void *vptr );
NestReplyStatus ReceiveNestMessage( NestConnection con, void *vptr );
NestReplyStatus ReceiveNestPartialMessage( NestConnection, void *, int, int * );

NestReplyStatus NestSendIndex( NestConnection, DynamicLard *index );
NestReplyStatus NestReceiveIndex( NestConnection, DynamicLard *,
                                  StringToServerFunc *,
                                  void *args );

bool SendSimpleRequest( NestConnection con, int request );
bool PrintFromSocket( NestConnection con );
bool PrintFromSocket( NestConnection con, FILE *out );

NestReplyStatus ReceiveNestAck( NestConnection con );
NestReplyStatus ReceiveNestAck( NestConnection con, void *vptr );

NestReplyStatus RequestWriteFile( const char *file, long offset, long length,
        NestConnection );

NestReplyStatus RequestReadFile( const char *file, long offset, long &length,
        NestConnection );

#endif
