/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef NEST_WORKER_H
#define NEST_WORKER_H

#include "nest_common.h"
#include "nest_filetransfer.h"
#include "nest_client.h"

// functions are defined in nest_worker_pool.C

class 
nestWorker {

public:

    nestWorker( pid_t pid, int stream, int id );

    bool sendMessage( const char * msg );

    bool canReceiveMessage( fd_set *readyfds );

    pid_t getPid( );

    int getStream( );

    bool isIdle( );

    void setIdle( int state );

    NestReplyStatus assignTask( nestClient *client ); 
    
    void endTask( bool success, long bytes_transferred );

    nestClient* getClient( );

    int  getID( );

private:

    pid_t pid;
    int   stream;
    int   id;    
    int   idle;
    nestFiletransfer *currentTask;
    nestClient *client;
};

#endif
